.TH vncpasswd 1 "" "KasmVNC" "Virtual Network Computing"
.SH NAME
vncpasswd \- setup VNC users and passwords
.SH SYNOPSIS
\fBvncpasswd\fR -u [\fIusername\fR] [\fI-wnod\fR] [\fIpasswd-file\fR]
.SH DESCRIPTION
.B vncpasswd
allows you to add users and passwords used to access VNC desktops. Multiple
users can be added, each with its own permissions. You can set view-only, use of
mouse and keyboard allowed (-w), user managment permissions (-o). See OPTIONS
below for details.

Its default behavior is to prompt for a VNC password and then store an
obfuscated version of this password to \fIpasswd-file\fR (or to
$HOME/.kasmpasswd if no password file is specified.)  The \fBvncserver\fP script
will ask you to add a user the first time you start a VNC desktop. HTTP Basic
Authentication will be used to ask for username and password, when you connect.

The password must be at least six characters long (maximum of 128 characters).
Note that the stored password is \fBnot\fP encrypted securely - anyone who has
access to this file can trivially find out the plain-text password, so
\fBvncpasswd\fP always sets appropriate permissions (read and write only by the
owner.)  However, when accessing a VNC desktop, a challenge-response mechanism
is used over the wire making it hard for anyone to crack the password simply by
snooping on the network.

.SH OPTIONS

.TP
.B \-u \fIname\fR

Specify user name. There can be multiple users.

.TP
.B \-w

Write permission. Enable user to use mouse and keyboard. The default mode is to
view only.

.TP
.B \-o

Owner permission. Allow the user to add/delete users and change their
permissions.

.TP
.B \-d

Delete user specified with \fI-u\fR. You need the owner permission for that.

.TP
.B \-n

Don't update their password, while updating permissions.

.SH FILES
.TP
$HOME/.kasmpasswd
Default location of the VNC password file.

.SH EXAMPLES
.TP
Create a new user foo that can to use mouse and keyboard:
$ vncpasswd -u foo -w

.TP
Create a new user foo that can view, but can't use mouse and keyboard:
$ vncpasswd -u foo

.TP
Create a new user foo that can add new users AND use mouse and keyboard:
$ vncpasswd -u foo -ow

.TP
Delete user foo
$ vncpasswd -u foo -d

.TP
Strip all permissions from user foo, making it view only. Don't touch password.
$ vncpasswd -u foo -n

.TP
Strip all permissions from user foo, making it view only. Change password.
$ vncpasswd -u foo

.TP
Add write permission for user foo. Don't touch password.
$ vncpasswd -u foo -w -n

.SH SEE ALSO
.BR vncserver (1),
.BR Xvnc (1)
.BR vncconfig (1),
.br
http://kasmweb.com

.SH AUTHORS
Kasm Technologies Corp., Tristan Richardson, RealVNC Ltd., D. R. Commander and others.

VNC was originally developed by the RealVNC team while at Olivetti
Research Ltd / AT&T Laboratories Cambridge.  TightVNC additions were
implemented by Constantin Kaplinsky. Many other people have since
participated in development, testing and support. KasmVNC has since
forked and the project and has added many modern features and made
the solution web native.

This manual is part of the KasmVNC software suite.